<?
include ("header.inc"); //some header
$prefix="/usr/local/";
$cif2cbf=$prefix."bin/cif2cbf"; // cif2cbf binary
$vcif=$prefix."bin/vcif"; // vcif binary
$corecif=$prefix."bin/corecif.dic"; // corecif dictionary path
$mmcif=$prefix."bin/mmcif.dic"; // mmcif dictionary path
$mmcifx=$prefix."bin/mmcif_pdbx.dic";//mmcif with PDB extensions dictionary path
$imgcif=$prefix."bin/imgcif.dic"; // imgcif dictionary path
$tmpfname = tempnam("/tmp", "CBFlib");

$file=$_FILES['userfile']['tmp_name']; // the name of the uploaded file
$origfile=$_FILES['userfile']['name']; // the name of the uploaded file
if ($_POST["program"] == "cif2cbf"){ // if VCIF2 is selected
	print "<h3> VCIF2 Output: </h3>\n";
	if ($_POST["line"] == "wide"){ // if wide lines are selected
		switch ($_POST["dict"]){
			case "none":
				//echo "Command: $cif2cbf -w $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -w $file /dev/null 2>$tmpfname"); // cif2cbf + wide; stderr goes to tmpfname
				break;
			case "corecif":
				//echo "Command: $cif2cbf -w -v $corecif $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -w -v $corecif $file /dev/null 2>$tmpfname"); // cif2cbf + wide + corecif; stderr goes to tmpfname
				break;	
			case "mmcif":
				//echo "Command: $cif2cbf -w -v $mmcif $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -w -v $mmcif $file /dev/null 2>$tmpfname"); // cif2cbf + wide + mmcif; stderr goes to tmpfname
				break;
			case "mmcifpdbx":
				//echo "Command: $cif2cbf -w -v $mmcifx $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -w -v $mmcifx $file /dev/null 2>$tmpfname"); // cif2cbf + wide + mmcif_PDBX; stderr goes to tmpfname
				break;		
			case "imgcif":
				//echo "Command: $cif2cbf -w -v $imgcif $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -w -v $imgcif $file /dev/null 2>$tmpfname"); // cif2cbf + wide + imgcif; stderr goes to tmpfname
				break;
		} 
	}else{
		switch ($_POST["dict"]){
			case "none":
				//echo "Command: $cif2cbf $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf $file /dev/null 2>$tmpfname"); // cif2cbf + wide; stderr goes to tmpfname
				break;
			case "corecif":
				//echo "Command: $cif2cbf -v $corecif $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -v $corecif $file /dev/null 2>$tmpfname"); // cif2cbf + wide + corecif; stderr goes to tmpfname
				break;	
			case "mmcif":
				//echo "$cif2cbf -v $mmcif $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -v $mmcif $file /dev/null 2>$tmpfname"); // cif2cbf + wide + mmcif; stderr goes to tmpfname
				break;	
			case "mmcifpdbx":
				//echo "Command: $cif2cbf -v $mmcifx $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -v $mmcifx $file /dev/null 2>$tmpfname"); // cif2cbf + wide + mmcif_PDBX; stderr goes to tmpfname
				break;		
			case "imgcif":
				//echo "Command: $cif2cbf -v $imgcif $origfile /dev/null 2>$tmpfname<br />";
				exec ("$cif2cbf -v $imgcif $file /dev/null 2>$tmpfname"); // cif2cbf + wide + imgcif; stderr goes to tmpfname
		}
	}
}else { // if VCIF1 is selected
	print "<h3> VCIF1 Output: </h3>\n";
	if ($_POST["line"] == "wide"){ // if wide lines are selected
		switch ($_POST["dict"]){
			case "none":
				exec ("$vcif -L 1 $file",$output); // vcif + wide; stderr goes to tmpfname tempfile
				break;
			default:
				echo "vcif does not support dictionaries\n";
				exec ("$vcif -L 1 $file",$output); // vcif + wide; stderr goes to tmpfname tempfile tempfile
				break;	
				
		} 
	}else{
		switch ($_POST["dict"]){
			case "none":
				exec ("$vcif -L 0 $file",$output); // vcif; stderr goes to tmpfname tempfile tempfile
				break;
			default:
				echo "vcif does not support dictionaries\n";
				exec ("$vcif -L 0 $file",$output); // vcif; stderr goes to tmpfname tempfile tempfile tempfile
				break;	
				
		} 
	}
}
exec ("cat $tmpfname|cut -d \" \" -f 5|grep \"[0-9]\"",$lines); // grep the linenumbers with warnings
$limit=sizeof($lines); // the number of warnings we have detected
$x=0;
print "\n<pre>\n";
if ($_POST["program"] == "vcif"){
	foreach ($output as $line){
		print $line."\n";
	}
}else{
	exec ("cat $tmpfname&&rm $tmpfname" , $output); // move the output to a variable
	foreach ($output as $v)
	{	
		if ($limit == 0 ) // if no warnings are found, just print whatever CBFlib printed
		{
			foreach( $output as $out){
				print $out."\n"; 
			}
			break;
		}
		if ($x >= $limit){ 
			print $v."\n"; // if this line is commented out, the web page will display only the read warnings
		}else{
			print ereg_replace($lines[$x],"<a href=\"#\\0\">\\0</a>", $v)."\n"; // add links to the line numbers
		}
		$x++;
	}
}
echo "</pre>";

$x=0;
foreach ($lines as $line) // here we print the code
{ 
	$linen = (int)$line -1;
	
	if ($x > 250){
		print '<h3> TOO MANY ERRORS (250+). SOMETHING IS WRONG!!!</h3>';
		break;
	}
	
	print "\n<hr />\n<p><a name=\"$line\"></a>The error message was:". str_replace("CBFlib:", "", $output[$x])."\n</p>\n<pre>\n";
	
	system("head -n $linen $file|cat -n|tail -n 2"); // print 2 lines before the line with a warning
	
	print "<strong>"; 
	system("head -n $line $file|cat -n|tail -n 1"); // print the line with a warning in bold
	if (strpos(exec("head -n $line $file|tail -n 1".'|grep \'^[[:space:]]\{1,\};\''),";")){
		print "\n\t####################################################################\n\t# </strong>Could line $line be a quoted string with unintended leading blank? <strong>#\n\t####################################################################\n\n";
	}
	print "</strong>";
	$linen = (int)$line+2;
	system("head -n $linen $file|cat -n|tail -n 2"); // print 2 lines after the line with a warning
	print "</pre>\n";
	
	$x++;
}
include ("footer.inc");// some footer
?>
